From 65ad37ee484c22dbb5822955c70fa3adabdd6cc5 Mon Sep 17 00:00:00 2001
From: Endi Sukma Dewata <edewata@redhat.com>
Date: Wed, 21 Dec 2011 11:00:13 -0600
Subject: [PATCH] Fixed PKI_COMPONENT_LIST in all build scripts.

The PKI_COMPONENT_LIST has been modified to include the new test
component to fix dependency issues.

Ticket #3
---
 pki/scripts/compose_dogtag_pki_theme_packages |    2 +-
 pki/scripts/compose_ipa_pki_theme_packages    |    2 +-
 pki/scripts/compose_pki_console_packages      |    2 +-
 pki/scripts/compose_pki_kra_packages          |    2 +-
 pki/scripts/compose_pki_migrate_packages      |    2 +-
 pki/scripts/compose_pki_ocsp_packages         |    2 +-
 pki/scripts/compose_pki_ra_packages           |    2 +-
 pki/scripts/compose_pki_tks_packages          |    2 +-
 pki/scripts/compose_pki_tps_packages          |    2 +-
 9 files changed, 9 insertions(+), 9 deletions(-)

diff --git a/pki/scripts/compose_dogtag_pki_theme_packages b/pki/scripts/compose_dogtag_pki_theme_packages
index 9d81b67b0d6b7e0bd4d4947f8d70df436b3624fc..8029b2f35b27f5f71b3e9236485d869008dc62e4 100755
--- a/pki/scripts/compose_dogtag_pki_theme_packages
+++ b/pki/scripts/compose_dogtag_pki_theme_packages
@@ -39,7 +39,7 @@ DOGTAG_PKI_THEME_VERSION="9.0.9"
 ##
 
 PKI_SPECS_FILE="${PKI_DIR}/specs/${DOGTAG_PKI_THEME}.spec"
-PKI_COMPONENT_LIST="common-ui ca-ui kra-ui ocsp-ui tks-ui ra-ui tps-ui console-ui"
+PKI_COMPONENT_LIST="test common-ui ca-ui kra-ui ocsp-ui tks-ui ra-ui tps-ui console-ui"
 
 
 ##
diff --git a/pki/scripts/compose_ipa_pki_theme_packages b/pki/scripts/compose_ipa_pki_theme_packages
index f2045886a0908f9626dd7771803a1d3d34ee1834..00eb0957bbd1bbafea10942b3bfcb628c385ed28 100755
--- a/pki/scripts/compose_ipa_pki_theme_packages
+++ b/pki/scripts/compose_ipa_pki_theme_packages
@@ -39,7 +39,7 @@ IPA_PKI_THEME_VERSION="9.0.5"
 ##
 
 PKI_SPECS_FILE="${PKI_DIR}/specs/${IPA_PKI_THEME}.spec"
-PKI_COMPONENT_LIST="common-ui ca-ui"
+PKI_COMPONENT_LIST="test common-ui ca-ui"
 
 
 ##
diff --git a/pki/scripts/compose_pki_console_packages b/pki/scripts/compose_pki_console_packages
index dab649b7aaa2e1bedb55aef96afc09d8f0d5e610..5b5281a2598db5d3493973ed7f25cb7660185ed0 100755
--- a/pki/scripts/compose_pki_console_packages
+++ b/pki/scripts/compose_pki_console_packages
@@ -39,7 +39,7 @@ PKI_CONSOLE_VERSION="9.0.5"
 ##
 
 PKI_SPECS_FILE="${PKI_DIR}/specs/${PKI_CONSOLE}.spec"
-PKI_COMPONENT_LIST="console"
+PKI_COMPONENT_LIST="test console"
 
 
 ##
diff --git a/pki/scripts/compose_pki_kra_packages b/pki/scripts/compose_pki_kra_packages
index b31ad5f42ce397085363fd9b2743303b14c1d52b..72ced759e04200c57c21bdddac29aa5cee300c5b 100755
--- a/pki/scripts/compose_pki_kra_packages
+++ b/pki/scripts/compose_pki_kra_packages
@@ -39,7 +39,7 @@ PKI_KRA_VERSION="9.0.9"
 ##
 
 PKI_SPECS_FILE="${PKI_DIR}/specs/${PKI_KRA}.spec"
-PKI_COMPONENT_LIST="kra"
+PKI_COMPONENT_LIST="test kra"
 
 
 ##
diff --git a/pki/scripts/compose_pki_migrate_packages b/pki/scripts/compose_pki_migrate_packages
index ac6f0048b7966749aced52352d507868a00f4202..7f0ca8ace990131f6457301f1a81dadfa06febf9 100755
--- a/pki/scripts/compose_pki_migrate_packages
+++ b/pki/scripts/compose_pki_migrate_packages
@@ -39,7 +39,7 @@ PKI_MIGRATE_VERSION="9.0.2"
 ##
 
 PKI_SPECS_FILE="${PKI_DIR}/specs/${PKI_MIGRATE}.spec"
-PKI_COMPONENT_LIST="migrate"
+PKI_COMPONENT_LIST="test migrate"
 
 
 ##
diff --git a/pki/scripts/compose_pki_ocsp_packages b/pki/scripts/compose_pki_ocsp_packages
index dd20e6f27f85ae0e0c184d631c356eb6cb2b66f7..47d8760ef528755a7d517bfb79d84df5fd3961ad 100755
--- a/pki/scripts/compose_pki_ocsp_packages
+++ b/pki/scripts/compose_pki_ocsp_packages
@@ -39,7 +39,7 @@ PKI_OCSP_VERSION="9.0.8"
 ##
 
 PKI_SPECS_FILE="${PKI_DIR}/specs/${PKI_OCSP}.spec"
-PKI_COMPONENT_LIST="ocsp"
+PKI_COMPONENT_LIST="test ocsp"
 
 
 ##
diff --git a/pki/scripts/compose_pki_ra_packages b/pki/scripts/compose_pki_ra_packages
index a9aa446ad54674584043bac910da753b6a39ef25..7595a4457064368d74a5bc04986c7367cea8dde4 100755
--- a/pki/scripts/compose_pki_ra_packages
+++ b/pki/scripts/compose_pki_ra_packages
@@ -39,7 +39,7 @@ PKI_RA_VERSION="9.0.4"
 ##
 
 PKI_SPECS_FILE="${PKI_DIR}/specs/${PKI_RA}.spec"
-PKI_COMPONENT_LIST="ra"
+PKI_COMPONENT_LIST="test ra"
 
 
 ##
diff --git a/pki/scripts/compose_pki_tks_packages b/pki/scripts/compose_pki_tks_packages
index d1dbd484235afa436119524089eb40283c2f711b..54bc58b144baf1c8d5b6c361f19a252d05f009cb 100755
--- a/pki/scripts/compose_pki_tks_packages
+++ b/pki/scripts/compose_pki_tks_packages
@@ -39,7 +39,7 @@ PKI_TKS_VERSION="9.0.8"
 ##
 
 PKI_SPECS_FILE="${PKI_DIR}/specs/${PKI_TKS}.spec"
-PKI_COMPONENT_LIST="tks"
+PKI_COMPONENT_LIST="test tks"
 
 
 ##
diff --git a/pki/scripts/compose_pki_tps_packages b/pki/scripts/compose_pki_tps_packages
index c5e3507dd13d23edc42603fedf9ba0dc2fec9a27..e7f642cd101ffd17eff0d11b918627639ee1a222 100755
--- a/pki/scripts/compose_pki_tps_packages
+++ b/pki/scripts/compose_pki_tps_packages
@@ -39,7 +39,7 @@ PKI_TPS_VERSION="9.0.7"
 ##
 
 PKI_SPECS_FILE="${PKI_DIR}/specs/${PKI_TPS}.spec"
-PKI_COMPONENT_LIST="tps"
+PKI_COMPONENT_LIST="test tps"
 
 
 ##
-- 
1.7.5.1